## wesnoth-1.9 1.9.12

=== CMakeLists.txt ===
# most stuff should be implemented so far, what is not working so far:
# * some other smaller stuff
# * nice INSTALL howto
# * Detect Python and install Python tools
# * Rewrite the po4a-update
# * Test everything
# * install .desktop files taking binary prefix and suffix into account

# set minimum version
cmake_minimum_required(VERSION 2.6.0)

if(COMMAND cmake_policy)
	cmake_policy(SET CMP0005 OLD)
endif(COMMAND cmake_policy)

set(CMAKE_ALLOW_LOOSE_LOOP_CONSTRUCTS true)

# use our own version of FindBoost.cmake and other Find* scripts
set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake)

find_package(SDL 1.2.7 REQUIRED)
find_package(Boost 1.36 REQUIRED COMPONENTS iostreams program_options regex system)

# no, gettext executables are not required when NLS is deactivated
find_package(Gettext)
# yes, libintl is *required* even when NLS is deactivated (this is to compile
# src/gettext.cpp since it includes libintl.h)
find_package(Libintl REQUIRED)

find_package(X11)

if(NOT MSVC)
	#needed to get some SDL defines in... (as of rev31694 -D_GNU_SOURCE=1 is required!)
	set(SDL_CONFIG "sdl-config" CACHE STRING "Path to sdl-config script")
	exec_program(${SDL_CONFIG} ARGS "--cflags" OUTPUT_VARIABLE SDL_CFLAGS)
	add_definitions(${SDL_CFLAGS})

	# Use the safer `mkstemp' instead of `tmpnam' on POSIX systems.
	add_definitions(-DLUA_USE_POSIX)
endif(NOT MSVC)

if(MSVC)
	add_definitions(-D_SCL_SECURE_NO_WARNINGS)
	add_definitions(-D_CRT_SECURE_NO_WARNINGS)
endif(MSVC)

#check for some compiler/arch specific things and export defines accordingly...
include(SearchForStuff)

#
# Options
#

#Path options
set(BINDIR "bin" CACHE STRING "Where to install binaries")
set(MANDIR "man" CACHE STRING "Where to install manpages")
set(DATAROOTDIR "${CMAKE_INSTALL_PREFIX}/share" CACHE STRING "Sets the root of data directories to a non-default location")
set(DOCDIR "${DATAROOTDIR}/doc/wesnoth" CACHE STRING "Sets the doc directory to a non-default location.")
set(DATADIRNAME "wesnoth" CACHE STRING "change the name of the directory for the read-only architecture-independent game data")
set(EXECUTABLE_OUTPUT_PATH "${CMAKE_BINARY_DIR}" CACHE STRING "change the dir where binaries are placed right at compile time")
set(LOCALEDIR "translations" CACHE STRING "change the name of the locale data directory to a non-default name")
set(PREFERENCES_DIR "" CACHE STRING "Use a non-default preferences directory (.wesnoth on unix)")

#Game options
option(ENABLE_FRIBIDI "Enable FriBIDi support" ON)

#server options
set(SERVER_UID "" CACHE STRING "User id of the user who runs wesnothd")
set(SERVER_GID "" CACHE STRING "Group id of the user who runs wesnothd")
set(FIFO_DIR "/var/run/wesnothd" CACHE STRING "Directory for the wesnothd fifo socket file")

#build options
option(ENABLE_GAME "Enable compilation of the game" ON)
option(ENABLE_CAMPAIGN_SERVER "Enable compilation of campaign server")
option(ENABLE_SERVER "Enable compilation of server" ON)
option(ENABLE_TOOLS "Enable building and installation of tools for artists and WML maintainers")
option(ENABLE_TESTS "Build unit tests")
option(ENABLE_NLS "Enable building of translations" ON)
option(ENABLE_POOL_ALLOC "Enable custom pool malloc" OFF)
option(ENABLE_LOW_MEM "Reduce memory usage by removing extra functionality" OFF)
option(ENABLE_OMP "Enables OpenMP, and has additional dependencies" OFF)

if(UNIX AND NOT APPLE AND NOT CYGWIN)
	option(ENABLE_DESKTOP_ENTRY "enable installation of desktop entry files" ON)
	set(ICONDIR "${DATAROOTDIR}/pixmaps" CACHE STRING "Sets the icon directory for desktop entry to a non-default location.")
	set(DESKTOPDIR "${DATAROOTDIR}/applications/" CACHE STRING "Sets the desktop file directory for desktop entry to a non-default location.")
endif(UNIX AND NOT APPLE AND NOT CYGWIN)

option(ENABLE_STRICT_COMPILATION "Sets the strict compilation mode" ON)
option(ENABLE_DEBUG_WINDOW_LAYOUT "Add the debug option to allow the generation of debug layout files in dot format" OFF)
option ( USE_ANA_NETWORK "Compile network module using ana" OFF )
option(ENABLE_DESIGN_DOCUMENTS "Enables the generation of design documents, and has additional dependencies" OFF)

#misc options
if(NOT MSVC)
	# Pot updates don't work at Windows so no reason to even try
	option(ENABLE_POT_UPDATE_TARGET "Enables the tools to update the pot files and manuals. This target has extra dependencies." OFF)
endif(NOT MSVC)

if(UNIX AND NOT APPLE AND NOT CYGWIN)
	option(ENABLE_NOTIFICATIONS "Enable Window manager notification messages" ON)
endif(UNIX AND NOT APPLE AND NOT CYGWIN)

set(BINARY_SUFFIX "" CACHE STRING "Suffix behind all binaries")
set(BINARY_PREFIX "" CACHE STRING "Prefix in front of all binaries")

#
# Handle options (set paths/definitions/etc...)
#

if(CMAKE_COMPILER_IS_GNUCXX)
	# Set our own default flags at first run.
	if(NOT CONFIGURED)

		if(ENABLE_STRICT_COMPILATION)
			# The current unit test code breaks strict aliasing with g++ 4.4.
			set(STRICT_FLAGS "-Werror -Wno-strict-aliasing")
		else(ENABLE_STRICT_COMPILATION)
			set(STRICT_FLAGS "")
		endif(ENABLE_STRICT_COMPILATION)

		# Strict compilation for C files is disabled until somebody wants to clean them.
		set(CMAKE_C_FLAGS "-O2 -W -Wall -ansi $ENV{CFLAGS}"
				CACHE STRING "Flags used by the C compiler during normal builds." FORCE)
		set(CMAKE_C_FLAGS_DEBUG "-O0 -DDEBUG -ggdb3 -W -Wall -ansi $ENV{CFLAGS}"
				CACHE STRING "Flags used by the C compiler during debug builds." FORCE)
		set(CMAKE_C_FLAGS_RELEASE "-O3 -DNDEBUG -W -Wall -ansi $ENV{CFLAGS} -Wno-unused"
				CACHE STRING "Flags used by the C compiler during release builds." FORCE)

		set(CMAKE_CXX_FLAGS "-O2 -W -Wall -std=c++98 ${STRICT_FLAGS} $ENV{CXXFLAGS}"
				CACHE STRING "Flags used by the CXX compiler during normal builds." FORCE)
		set(CMAKE_CXX_FLAGS_DEBUG "-O0 -DDEBUG -ggdb3 -W -Wall -std=c++98 ${STRICT_FLAGS} $ENV{CXXFLAGS}"
				CACHE STRING "Flags used by the CXX compiler during debug builds." FORCE)
		set(CMAKE_CXX_FLAGS_RELEASE "-O3 -DNDEBUG -W -Wall -std=c++98 ${STRICT_FLAGS} $ENV{CXXFLAGS} -Wno-unused"
				CACHE STRING "Flags used by the CXX compiler during release builds." FORCE)

	endif(NOT CONFIGURED)

endif(CMAKE_COMPILER_IS_GNUCXX)

if(UNIX AND NOT CMAKE_COMPILER_IS_GNUCXX)
	# Assume the compiler is the clang compiler.
	set(CMAKE_EXE_LINKER_FLAGS "-lstdc++ -lm ${CMAKE_EXE_LINKER_FLAGS}")
endif(UNIX AND NOT CMAKE_COMPILER_IS_GNUCXX)

# compose datadir path of datarootdir and datadirname
set(DATADIR ${DATAROOTDIR}/${DATADIRNAME})

if(NOT WIN32)
	add_definitions(-DWESNOTH_PATH=\\\"${DATADIR}\\\")
endif(NOT WIN32)

if(NOT ENABLE_POOL_ALLOC OR WIN32)
	add_definitions(-DDISABLE_POOL_ALLOC)
endif(NOT ENABLE_POOL_ALLOC OR WIN32)

if(X11_FOUND)
	add_definitions(-D_X11)
endif(X11_FOUND)

add_definitions(-DLOCALEDIR=\\\"${LOCALEDIR}\\\")

# When the path starts with a / on a Unix system it's an absolute path.
# This means that on Windows the path used is always relative.
if(LOCALEDIR MATCHES "^/")
	add_definitions(-DHAS_RELATIVE_LOCALEDIR=0)
	set(LOCALE_INSTALL ${LOCALEDIR})
else(LOCALEDIR MATCHES "^/")
	add_definitions(-DHAS_RELATIVE_LOCALEDIR=1)
	set(LOCALE_INSTALL ${DATADIR}/${LOCALEDIR})
endif(LOCALEDIR MATCHES "^/")

add_definitions(-DFIFODIR=\\\"${FIFO_DIR}\\\")

if(PREFERENCES_DIR)
	add_definitions(-DPREFERENCES_DIR=\\\"${PREFERENCES_DIR}\\\")
endif(PREFERENCES_DIR)

if(ENABLE_LOW_MEM)
	add_definitions(-DLOW_MEM)
endif(ENABLE_LOW_MEM)

if(ENABLE_OMP)
	find_package(OpenMP REQUIRED)
	set(CMAKE_C_FLAGS "${OpenMP_C_FLAGS} ${CMAKE_C_FLAGS}")
	set(CMAKE_CXX_FLAGS "${OpenMP_CXX_FLAGS} ${CMAKE_C_FLAGS}")
endif(ENABLE_OMP)

if(ENABLE_DEBUG_WINDOW_LAYOUT)
	add_definitions(-DDEBUG_WINDOW_LAYOUT_GRAPHS)
endif(ENABLE_DEBUG_WINDOW_LAYOUT)

#
# Libraries that are only required by some targets
#

if(ENABLE_TOOLS OR ENABLE_GAME OR ENABLE_TESTS)
	find_package( SDL_image 1.2 REQUIRED )
endif(ENABLE_TOOLS OR ENABLE_GAME OR ENABLE_TESTS)
if(ENABLE_GAME OR ENABLE_TESTS)
	find_package( SDL_mixer 1.2 REQUIRED )
	find_package( SDL_ttf 2.0.8 REQUIRED )

	if(NOT MSVC)
		find_package( PkgConfig REQUIRED )
		pkg_check_modules( PANGOCAIRO REQUIRED pangocairo>=1.14.8 )
		pkg_check_modules( FONTCONFIG REQUIRED fontconfig>=2.4.1 )
	endif(NOT MSVC)

endif(ENABLE_GAME OR ENABLE_TESTS)
if(ENABLE_GAME OR ENABLE_SERVER OR ENABLE_CAMPAIGN_SERVER OR ENABLE_TESTS)
	find_package( SDL_net REQUIRED )
endif(ENABLE_GAME OR ENABLE_SERVER OR ENABLE_CAMPAIGN_SERVER OR ENABLE_TESTS)
if(ENABLE_TOOLS)
	find_package( ZLIB REQUIRED )
	find_package( PNG REQUIRED )
endif(ENABLE_TOOLS)
if(ENABLE_TESTS)
	find_package( Boost 1.36 REQUIRED COMPONENTS unit_test_framework )
endif(ENABLE_TESTS)
if(ENABLE_GAME)
	find_package( FriBiDi )
	if(ENABLE_FRIBIDI AND FRIBIDI_LIBRARIES)
		add_definitions(-DHAVE_FRIBIDI)
	elseif(ENABLE_FRIBIDI AND NOT FRIBIDI_LIBRARIES)
		message("Could not find FriBiDi. Disabling FriBiDi support.")
	endif()

	if(ENABLE_NOTIFICATIONS)
		pkg_check_modules(LIBDBUS dbus-1)
		if(LIBDBUS_FOUND)
			add_definitions(-DHAVE_LIBDBUS)
		else(LIBDBUS_FOUND)
			message("Could not find dbus-1, Disabling notification support.")
		endif(LIBDBUS_FOUND)
	endif(ENABLE_NOTIFICATIONS)

endif(ENABLE_GAME)

if(ENABLE_POT_UPDATE_TARGET)
	find_package(TranslationTools REQUIRED)
endif(ENABLE_POT_UPDATE_TARGET)

# get languages
file(READ po/LINGUAS LINGUAS)
string(REPLACE "\n" "" LINGUAS ${LINGUAS})
separate_arguments(LINGUAS)

#
# Include subdirectories
#

add_subdirectory(doc)

if(GETTEXT_FOUND AND ENABLE_NLS)
	add_subdirectory(po)
endif (GETTEXT_FOUND AND ENABLE_NLS)

add_subdirectory(src)

#
# Install files
#
install(DIRECTORY data fonts images sounds DESTINATION ${DATADIR} USE_SOURCE_PERMISSIONS PATTERN ".svn" EXCLUDE )


#
# Install desktop file so wesnoth appears in the application start menu with an icon
# TODO: string replacement to have the real binary name in does not work atm, because in the Categories= block semicolons are lost...
#
if(ENABLE_DESKTOP_ENTRY AND ENABLE_GAME)
	# do some crude string replacing to have the real binary name in the .desktop file (read in original .desktop file, replace the Exec= line with the correct value and output the generated file)
	#  file(READ icons/wesnoth.desktop wesnoth-desktop-orig)
	#string(REGEX REPLACE "(\nName.*=.*)\n" "\\1 (${BINARY_SUFFIX})\n" wesnoth-desktop-modified ${wesnoth-desktop-orig} )
	#  string(REPLACE "Exec=wesnoth" "Exec=${BINARY_PREFIX}wesnoth${BINARY_SUFFIX}" wesnoth-desktop-modified ${wesnoth-desktop-orig} )
	#  file(WRITE ${CMAKE_CURRENT_BINARY_DIR}/${BINARY_PREFIX}wesnoth${BINARY_SUFFIX}.desktop ${wesnoth-desktop-modified} )

	#execute_process(COMMAND sed "-i" "'s/^\(Name.*=.*\)$/\1TEST/g'" ${CMAKE_CURRENT_BINARY_DIR}/${BINARY_PREFIX}wesnoth${BINARY_SUFFIX}.desktop )
	#exec_program(sed ARGS "-i" "'s/^\(Name.*=.*\)$/\1TEST/g'" ${CMAKE_CURRENT_BINARY_DIR}/${BINARY_PREFIX}wesnoth${BINARY_SUFFIX}.desktop )
	# install the generated .desktop file
	#  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${BINARY_PREFIX}wesnoth${BINARY_SUFFIX}.desktop DESTINATION ${DESKTOPDIR} )
	install(FILES icons/wesnoth.desktop DESTINATION ${DESKTOPDIR} )
	install(FILES icons/wesnoth-icon.png DESTINATION ${ICONDIR} )

	# do some crude string replacing to have the real binary name in the .desktop file (read in original .desktop file, replace the Exec= line with the correct value and output the generated file)
	#    file(READ icons/wesnoth_editor.desktop wesnoth-editor-desktop-orig)
	#    string(REPLACE "Exec=wesnoth -e" "Exec=${BINARY_PREFIX}wesnoth${BINARY_SUFFIX} -e" wesnoth-editor-desktop-modified ${wesnoth-editor-desktop-orig} )
	#    file(WRITE ${CMAKE_CURRENT_BINARY_DIR}/${BINARY_PREFIX}wesnoth_editor${BINARY_SUFFIX}.desktop ${wesnoth-editor-desktop-modified} )
	# install the generated .desktop file
	#    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${BINARY_PREFIX}wesnoth_editor${BINARY_SUFFIX}.desktop DESTINATION ${DESKTOPDIR} )
	install(FILES icons/wesnoth_editor.desktop DESTINATION ${DESKTOPDIR} )

=== SConstruct ===
# vi: syntax=python:et:ts=4
#
# SCons build description for the Wesnoth project
#
# Prerequisites are:
# 1. Subversion command-line client programs svnstatus and svnversion.
# 2. msgfmt(1) for making builds with i18n support.
# 3. graph-includes for making the project dependency graph.

EnsureSConsVersion(0,98,3)

import os, sys, shutil, re, commands
from glob import glob
from subprocess import Popen, PIPE, call
from os import access, F_OK

# Warn user of current set of build options.
if os.path.exists('.scons-option-cache'):
    optfile = file('.scons-option-cache')
    print "Saved options:", optfile.read().replace("\n", ", ")[:-2]
    optfile.close()

#
# Get the Wesnoth version number
#

config_h_re = re.compile(r"^.*#define\s*(\S*)\s*\"(\S*)\".*$", re.MULTILINE)
build_config = dict( config_h_re.findall(File("src/wesconfig.h").get_contents()) )
try:
    version = build_config["VERSION"]
    print "Building Wesnoth version %s" % version
except KeyError:
    print "Couldn't determin the Wesnoth version number, bailing out!"
    sys.exit(1)

#
# Build-control options
#

opts = Variables('.scons-option-cache')

def OptionalPath(key, val, env):
    if val:
        PathVariable.PathIsDir(key, val, env)

opts.AddVariables(
    ListVariable('default_targets', 'Targets that will be built if no target is specified in command line.',
        "wesnoth,wesnothd", Split("wesnoth wesnothd campaignd cutter exploder test")),
    EnumVariable('build', 'Build variant: debug, release profile or base (no subdirectory)', "release", ["release", "debug", "glibcxx_debug", "profile","base"]),
    PathVariable('build_dir', 'Build all intermediate files(objects, test programs, etc) under this dir', "build", PathVariable.PathAccept),
    ('extra_flags_config', 'Extra compiler and linker flags to use for configuration and all builds', ""),
    ('extra_flags_base', 'Extra compiler and linker flags to use for release builds', ""),
    ('extra_flags_release', 'Extra compiler and linker flags to use for release builds', ""),
    ('extra_flags_debug', 'Extra compiler and linker flags to use for debug builds', ""),
    ('extra_flags_profile', 'Extra compiler and linker flags to use for profile builds', ""),
    PathVariable('bindir', 'Where to install binaries', "bin", PathVariable.PathAccept),
    ('cachedir', 'Directory that contains a cache of derived files.', ''),
    PathVariable('datadir', 'read-only architecture-independent game data', "$datarootdir/$datadirname", PathVariable.PathAccept),
    PathVariable('fifodir', 'directory for the wesnothd fifo socket file', "/var/run/wesnothd", PathVariable.PathAccept),
    BoolVariable('fribidi','Clear to disable bidirectional-language support', True),
    BoolVariable('desktop_entry','Clear to disable desktop-entry', True),
    PathVariable('datarootdir', 'sets the root of data directories to a non-default location', "share", PathVariable.PathAccept),
    PathVariable('datadirname', 'sets the name of data directory', "wesnoth$version_suffix", PathVariable.PathAccept),
    PathVariable('desktopdir', 'sets the desktop entry directory to a non-default location', "$datarootdir/applications", PathVariable.PathAccept),
    PathVariable('icondir', 'sets the icons directory to a non-default location', "$datarootdir/icons", PathVariable.PathAccept),
    BoolVariable('internal_data', 'Set to put data in Mac OS X application fork', False),
    PathVariable('localedirname', 'sets the locale data directory to a non-default location', "translations", PathVariable.PathAccept),
    PathVariable('mandir', 'sets the man pages directory to a non-default location', "$datarootdir/man", PathVariable.PathAccept),
    PathVariable('docdir', 'sets the doc directory to a non-default location', "$datarootdir/doc/wesnoth", PathVariable.PathAccept),
    PathVariable('python_site_packages_dir', 'sets the directory where python modules are installed', "lib/python/site-packages/wesnoth", PathVariable.PathAccept),
    BoolVariable('lowmem', 'Set to reduce memory usage by removing extra functionality', False),
    BoolVariable('notifications', 'Enable support for desktop notifications', True),
    BoolVariable('nls','enable compile/install of gettext message catalogs',True),
    PathVariable('prefix', 'autotools-style installation prefix', "/usr/local", PathVariable.PathAccept),
    PathVariable('prefsdir', 'user preferences directory', "", PathVariable.PathAccept),
    PathVariable('destdir', 'prefix to add to all installation paths.', "/", PathVariable.PathAccept),
    BoolVariable('prereqs','abort if prerequisites cannot be detected',True),
    ('program_suffix', 'suffix to append to names of installed programs',"$version_suffix"),
    ('version_suffix', 'suffix that will be added to default values of prefsdir, program_suffix and datadirname', ""),
    BoolVariable('raw_sockets', 'Set to use raw receiving sockets in the multiplayer network layer rather than the SDL_net facilities', False),
    BoolVariable('forum_user_handler', 'Enable forum user handler in wesnothd', False),
    BoolVariable('use_network_ana', 'Use the new network api', False),
    BoolVariable('pool_alloc', 'Enable custom pool malloc', False),
    ('server_gid', 'group id of the user who runs wesnothd', ""),
    ('server_uid', 'user id of the user who runs wesnothd', ""),
    BoolVariable('strict', 'Set to strict compilation', False),
    BoolVariable('static_test', 'Staticaly build against boost test (Not supported yet)', False),
    BoolVariable('verbose', 'Emit progress messages during data installation.', False),
    PathVariable('sdldir', 'Directory of SDL installation.', "", OptionalPath),
    PathVariable('boostdir', 'Directory of boost installation.', "", OptionalPath),
    PathVariable('boostlibdir', 'Directory where boost libraries are installed.', "", OptionalPath),
    ('boost_suffix', 'Suffix of boost libraries.'),
    PathVariable('gettextdir', 'Root directory of Gettext\'s installation.', "", OptionalPath), 
    PathVariable('gtkdir', 'Directory where GTK SDK is installed.', "", OptionalPath),
    PathVariable('luadir', 'Directory where Lua binary package is unpacked.', "", OptionalPath),
    ('host', 'Cross-compile host.', ''),
    ('jobs', 'Set the number of parallel compilations', "1", lambda key, value, env: int(value), int),
    BoolVariable('distcc', 'Use distcc', False),
    BoolVariable('ccache', "Use ccache", False),
    ('cxxtool', 'Set c++ compiler command if not using standard compiler.'),
    BoolVariable('cxx0x', 'Use C++0x features.', False),
    BoolVariable('openmp', 'Enable openmp use.', False),
    BoolVariable("fast", "Make scons faster at cost of less precise dependency tracking.", False),
    BoolVariable("lockfile", "Create a lockfile to prevent multiple instances of scons from being run at the same time on this working copy.", False)
    )

#
# Setup
#

sys.path.insert(0, "./scons")
env = Environment(tools=["tar", "gettext", "install", "python_devel", "scanreplace"], options = opts, toolpath = ["scons"])

if env["lockfile"]:
    print "Creating lockfile"
    lockfile = os.path.abspath("scons.lock")
    open(lockfile, "wx").write(str(os.getpid()))
    import atexit
    atexit.register(os.remove, lockfile)

opts.Save('.scons-option-cache', env)
env.SConsignFile("$build_dir/sconsign.dblite")

# Make sure the user's environment is always available
env['ENV']['PATH'] = os.environ["PATH"]
if env["PLATFORM"] == "win32":
    env.Tool("mingw")
elif env["PLATFORM"] == "sunos":
    env.Tool("sunc++")
    env.Tool("suncc")
    env.Tool("sunar")
    env.Tool("sunlink")
    env.Append(CXXFLAGS = Split("-library=stlport4 -staticlib=stlport4 -norunpath -features=tmplife -features=tmplrefstatic -features=extensions"))
    env.Append(LINKFLAGS = Split("-library=stlport4 -staticlib=stlport4 -lsocket -lnsl -lboost_iostreams -L. -R."))
    env['CC'] = env['CXX']
else:
    from cross_compile import *
    setup_cross_compile(env)

if env.get('cxxtool',""):
    env['CXX'] = env['cxxtool']
    if 'HOME' in os.environ:
        env['ENV']['HOME'] = os.environ['HOME']

if env['jobs'] > 1:
    SetOption("num_jobs", env['jobs'])

if env['distcc']: 
    env.Tool('distcc')

if env['ccache']: env.Tool('ccache')


Help("""Arguments may be a mixture of switches and targets in any order.
Switches apply to the entire build regardless of where they are in the order.
Important switches include:

    prefix=/usr     probably what you want for production tools
    build=base      build directly in the distribution root;
                    you'll need this if you're trying to use Emacs compile mode.
    build=release   build the release build variant with appropriate flags
                        in build/release and copy resulting binaries
                        into distribution/working copy root.
    build=debug     same for debug build variant, binaries will be copied with -debug suffix

With no arguments, the recipe builds wesnoth and wesnothd.  Available
build targets include the individual binaries:

    wesnoth wesnothd campaignd exploder cutter test

You can make the following special build targets:

    all = wesnoth exploder cutter wesnothd campaignd (*).
    TAGS = build tags for Emacs (*).
    wesnoth-deps.png = project dependency graph
    install = install all executables that currently exist, and any data needed
    install-wesnothd = install the Wesnoth multiplayer server.
    install-campaignd = install the Wesnoth campaign server.
    install-cutter = install the castle cutter
    install-exploder = install the castle exploder
    install-pytools = install all Python tools and modules
    uninstall = uninstall all executables, tools, modules, and servers.
    pot-update = generate gettext message catalog templates and merge them with localized message catalogs
    update-po = merge message catalog templates with localized message catalogs for particular lingua
    update-po4a = update translations of manual and manpages
    af bg ca ... = linguas for update-po
    dist = make distribution tarball as wesnoth.tar.bz2 (*).
    data-dist = make data tarball as wesnoth-data.tar.bz2 (*).
    binary-dist = make data tarball as wesnoth-binaries.tar.bz2 (*).
    wesnoth-bundle = make Mac OS application bundle from game (*)
    sanity-check = run a pre-release sanity check on the distribution.
    manual = regenerate English-language manual and, possibly, localized manuals if appropriate xmls exist.

Files made by targets marked with '(*)' are cleaned by 'scons -c all'

Options are cached in a file named .scons-option-cache and persist to later
invocations.  The file is editable.  Delete it to start fresh.  Current option
values can be listed with 'scons -h'.

If you set CXXFLAGS and/or LDFLAGS in the environment, the values will
be appended to the appropriate variables within scons.
""" + opts.GenerateHelpText(env, sort=cmp))

if GetOption("help"):
    Return()

if env["cachedir"] and not env['ccache']:
    CacheDir(env["cachedir"])

if env["fast"]:
    env.Decider('MD5-timestamp')
    SetOption('max_drift', 1)
    SetOption('implicit_cache', 1)

if not os.path.isabs(env["prefix"]):
    print "Warning: prefix is set to relative dir. destdir setting will be ignored."
    env["destdir"] = ""

#
# work around long command line problem on windows
# see http://www.scons.org/wiki/LongCmdLinesOnWin32
#
if sys.platform == 'win32':
    try:
        import win32file
        import win32event
        import win32process
        import win32security
        import string

        def my_spawn(sh, escape, cmd, args, spawnenv):
            for var in spawnenv:
                spawnenv[var] = spawnenv[var].encode('ascii', 'replace')

            sAttrs = win32security.SECURITY_ATTRIBUTES()
            StartupInfo = win32process.STARTUPINFO()
            newargs = string.join(map(escape, args[1:]), ' ')
            cmdline = cmd + " " + newargs

            # check for any special operating system commands

=== src/CMakeLists.txt ===
## some includes ##
if(MSVC)
	# This seems to break on some Linux systems in combination with strict
	# compilation, so disabled for now. The problem occurred on Gentoo with
	# boost 1.37. Debian with boost 1.34, 1.35 and 1.38 works properly.
	include_directories( ${Boost_INCLUDE_DIR} )

	#additional MSVC includes
	include_directories( ${PANGO_INCLUDE_DIR} )
	include_directories( ${CAIRO_INCLUDE_DIR} )
	include_directories( ${GLIB_INCLUDE_DIR} )
	include_directories( ${GLIBCONFIG_INCLUDE_PATH} )
else(MSVC)
	include_directories( ${FONTCONFIG_INCLUDE_DIRS} )
endif(MSVC)


include_directories( ${SDL_INCLUDE_DIR} )
include_directories( ${PANGOCAIRO_INCLUDE_DIRS} )
include_directories( ${GETTEXT_INCLUDE_DIR} )
include_directories( ${LIBDBUS_INCLUDE_DIRS} )
include_directories( ${LIBINTL_INCLUDE_DIR} )

#optional dependencies
if(SDLIMAGE_INCLUDE_DIR)
	include_directories( ${SDLIMAGE_INCLUDE_DIR} )
endif()
if(SDLMIXER_INCLUDE_DIR)
	include_directories( ${SDLMIXER_INCLUDE_DIR} )
endif()
if(SDLNET_INCLUDE_DIR)
	include_directories( ${SDLNET_INCLUDE_DIR} )
endif()
if(SDLTTF_INCLUDE_DIR)
	include_directories( ${SDLTTF_INCLUDE_DIR} )
endif()
if(ZLIB_INCLUDE_DIR)
	include_directories( ${ZLIB_INCLUDE_DIR} )
endif()

set(network_implementation_files network.cpp network_worker.cpp)

if(USE_ANA_NETWORK)
	set(network_implementation_files network_ana.cpp network_manager_ana.cpp)
	message(STATUS "Compiling network module with ana: ${network_implementation_files}")

	set(ANA_LIBRARIES ana-static)

	add_subdirectory(ana/src)
endif(USE_ANA_NETWORK)

# needed to get include paths in the subfolders correct
include_directories( ${CMAKE_SOURCE_DIR}/src/ )
# needed to have the generated config.h used, too
include_directories( ${CMAKE_CURRENT_BINARY_DIR} )

link_directories(
	${Boost_LIBRARY_DIRS}
	${PANGOCAIRO_LIBRARY_DIRS}
	${FONTCONFIG_LIBRARY_DIRS}
	${LIBDBUS_LIBRARY_DIRS}
)

if(MSVC)
	# Since MSVC does autolinking of boost adding those files will duplicate
	# the includes and cause build errors.
	set(common-external-libs
		${SDL_LIBRARY}
		${SDLMAIN_LIBRARY}
		${LIBINTL_LIBRARY}
		ws2_32.lib
	)
else(MSVC)
	set(common-external-libs
		${SDL_LIBRARY}
		${Boost_IOSTREAMS_LIBRARY}
		${Boost_REGEX_LIBRARY}
		${Boost_PROGRAM_OPTIONS_LIBRARY}
		${LIBINTL_LIBRARIES}
	)
endif(MSVC)

set(game-external-libs
	${common-external-libs}
	${Boost_SYSTEM_LIBRARIES}
	${SDLIMAGE_LIBRARY}
	${SDLMIXER_LIBRARY}
	${ANA_LIBRARIES}
	${SDLTTF_LIBRARY}
	${PANGOCAIRO_LIBRARIES}
	${FONTCONFIG_LIBRARIES}
	${LIBDBUS_LIBRARIES}
)

if(MSVC)
	set(game-external-libs
		${game-external-libs}
		${PANGO_LIBRARY}
		${PANGOCAIRO_LIBRARY}
		${CAIRO_LIBRARY}
		${GOBJECT_LIBRARY}
	)
endif(MSVC)

if(USE_ANA_NETWORK)
	set(server-external-libs
		${common-external-libs}
		${ANA_LIBRARIES}
)
else(USE_ANA_NETWORK)
	set(server-external-libs
		${common-external-libs}
		${SDLNET_LIBRARY}
	)
	set(game-external-libs
		${game-external-libs}
		${SDLNET_LIBRARY}
	)
endif(USE_ANA_NETWORK)

set(tools-external-libs
	${common-external-libs}
	${SDLIMAGE_LIBRARY}
)

if(ENABLE_FRIBIDI AND FRIBIDI_LIBRARIES)
	include_directories( ${FRIBIDI_INCLUDE_DIR} )
	set(game-external-libs ${game-external-libs} ${FRIBIDI_LIBRARIES})
endif(ENABLE_FRIBIDI AND FRIBIDI_LIBRARIES)

if(X11_FOUND)
	include_directories( ${X11_INCLUDE_DIR} )
	set(game-external-libs ${game-external-libs} ${X11_LIBRARIES})
endif(X11_FOUND)
#
# Create targets for revision.hpp
#

find_program(SVNVERSION_EXECUTABLE "svnversion")

set(REVISION_FILE)
if(SVNVERSION_EXECUTABLE)
	execute_process(COMMAND ${SVNVERSION_EXECUTABLE} -n ${CMAKE_SOURCE_DIR}
		OUTPUT_VARIABLE SVN_VERSION)
	if(SVN_VERSION MATCHES [0-9]+.*)
		add_custom_target(update_revision ALL
			COMMAND ${CMAKE_COMMAND}
				-DSVNVERSION_EXECUTABLE="${SVNVERSION_EXECUTABLE}"
				-DSRC_DIR="${CMAKE_SOURCE_DIR}"
				-P "${CMAKE_MODULE_PATH}/revision.cmake"
			WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
			COMMENT "Updating revision")

		set(REVISION_FILE revision.hpp)
		set_source_files_properties(
			revision.hpp
			PROPERTIES GENERATED true)
		add_definitions(-DHAVE_REVISION)

		set(UPDATE_REVISION ON CACHE INTERNAL "")
	endif(SVN_VERSION MATCHES [0-9]+.*)
endif(SVNVERSION_EXECUTABLE)

if(MSVC)
	SOURCE_GROUP("src" REGULAR_EXPRESSION ".*")
	SOURCE_GROUP("src ai" REGULAR_EXPRESSION "ai/.*")
	SOURCE_GROUP("src ai composite" REGULAR_EXPRESSION "ai/composite/.*")
	SOURCE_GROUP("src ai default" REGULAR_EXPRESSION "ai/default/.*")
	SOURCE_GROUP("src ai dfool" REGULAR_EXPRESSION "ai/dfool/.*")
	SOURCE_GROUP("src ai formula" REGULAR_EXPRESSION "ai/formula/.*")
	SOURCE_GROUP("src ai testing" REGULAR_EXPRESSION "ai/testing/.*")
	SOURCE_GROUP("src campaign_server" REGULAR_EXPRESSION "campaign_server/.*")
	SOURCE_GROUP("src editor" REGULAR_EXPRESSION "editor/.*")
	SOURCE_GROUP("src gui" REGULAR_EXPRESSION "gui/.*")
	SOURCE_GROUP("src gui auxiliary" REGULAR_EXPRESSION "gui/auxiliary/.*")
	SOURCE_GROUP("src gui auxiliary event" REGULAR_EXPRESSION "gui/auxiliary/event/.*")
	SOURCE_GROUP("src gui auxiliary widget_definition" REGULAR_EXPRESSION "gui/auxiliary/widget_definition/.*")
	SOURCE_GROUP("src gui auxiliary window_builder" REGULAR_EXPRESSION "gui/auxiliary/window_builder/.*")
	SOURCE_GROUP("src gui dialogs" REGULAR_EXPRESSION "gui/dialogs/.*")
	SOURCE_GROUP("src gui dialogs lobby" REGULAR_EXPRESSION "gui/dialogs/lobby/.*")
	SOURCE_GROUP("src lua" REGULAR_EXPRESSION "lua/.*")
	SOURCE_GROUP("src widgets" REGULAR_EXPRESSION "widgets/.*")
	SOURCE_GROUP("src gui widgets" REGULAR_EXPRESSION "gui/widgets/.*")
	SOURCE_GROUP("src pathfind" REGULAR_EXPRESSION "pathfind/.*")
	SOURCE_GROUP("src scripting" REGULAR_EXPRESSION "scripting/.*")
	SOURCE_GROUP("src serialization" REGULAR_EXPRESSION "serialization/.*")
	SOURCE_GROUP("src server" REGULAR_EXPRESSION "server/.*")
	SOURCE_GROUP("src storyscreen" REGULAR_EXPRESSION "storyscreen/.*")
	SOURCE_GROUP("src tests" REGULAR_EXPRESSION "tests/.*")
	SOURCE_GROUP("src tests gui" REGULAR_EXPRESSION "tests/gui/.*")
	SOURCE_GROUP("src tests utils" REGULAR_EXPRESSION "tests/utils/.*")
	SOURCE_GROUP("src tools" REGULAR_EXPRESSION "tools/.*")
	SOURCE_GROUP("src tools schema" REGULAR_EXPRESSION "tools/schema/.*")
	SOURCE_GROUP("src utils" REGULAR_EXPRESSION "utils/.*")
	SOURCE_GROUP("src whiteboard" REGULAR_EXPRESSION "whiteboard/.*")

endif(MSVC)


########### libwesnoth-core ###############

set(libwesnoth-core_STAT_SRC
	color_range.cpp
	config.cpp
	filesystem.cpp
	game_config.cpp
	gettext.cpp
	hash.cpp
	log.cpp
	map.cpp
	map_location.cpp
	md5.cpp
	thread.cpp
	tstring.cpp
	util.cpp
	version.cpp
	serialization/binary_or_text.cpp
	serialization/parser.cpp
	serialization/preprocessor.cpp
	serialization/string_utils.cpp
	serialization/tokenizer.cpp
	serialization/validator.cpp
	${REVISION_FILE}
)

if(ENABLE_POOL_ALLOC AND NOT WIN32)
	set(libwesnoth-core_STAT_SRC
		${libwesnoth-core_STAT_SRC}
		malloc.c
		poolalloc.c
	)
endif(ENABLE_POOL_ALLOC AND NOT WIN32)

# a 'lib' is automatically set in front when creating the library (as in the filename)
# internal reference is the name given here
add_library(wesnoth-core STATIC EXCLUDE_FROM_ALL ${libwesnoth-core_STAT_SRC})

if(UPDATE_REVISION)
	add_dependencies(wesnoth-core update_revision)
endif(UPDATE_REVISION)

########### libwesnoth-lua ###############

set(libwesnoth-lua_STAT_SRC
	lua_jailbreak_exception.cpp
	lua/lapi.c
	lua/lcode.c
	lua/ldebug.c
	lua/ldo.c
	lua/ldump.c
	lua/lfunc.c
	lua/lgc.c
	lua/llex.c
	lua/lmem.c
	lua/lobject.c
	lua/lopcodes.c
	lua/lparser.c
	lua/lstate.c
	lua/lstring.c
	lua/ltable.c
	lua/ltm.c
	lua/lundump.c
	lua/lvm.c
	lua/lzio.c
	lua/lauxlib.c
	lua/lbaselib.c
	lua/ldblib.c
	lua/liolib.c
	lua/lmathlib.c
	lua/loslib.c
	lua/ltablib.c
	lua/lstrlib.c
	lua/loadlib.c
	lua/linit.c
)
# We explicitly want lua compiled as C++ version, so this line is required:
set_source_files_properties(${libwesnoth-lua_STAT_SRC} PROPERTIES LANGUAGE CXX)

if(UNIX AND NOT CMAKE_COMPILER_IS_GNUCXX)
	# Assume the compiler is the clang compiler.
	# It needs the files to be forced as c++ manually, it might be a newer
	# version of cmake will be able to this for us.
	set_source_files_properties(${libwesnoth-lua_STAT_SRC} PROPERTIES COMPILE_FLAGS "-x c++")
endif(UNIX AND NOT CMAKE_COMPILER_IS_GNUCXX)

# a 'lib' is automatically set in front when creating the library (as in the filename)
# internal reference is the name given here
add_library(wesnoth-lua STATIC EXCLUDE_FROM_ALL ${libwesnoth-lua_STAT_SRC})


########### Old style cast flags ###############

# Disable the setting of -Wold-style-cast on some targets.
# old style casts are not wanted by our coding style but some C based code
# uses it. Force the flag off for these files. (We don't enable it in our
# generic compiler flags, but allows people to do it.)
if(CMAKE_COMPILER_IS_GNUCXX)
	set_target_properties(wesnoth-lua PROPERTIES COMPILE_FLAGS "-Wno-old-style-cast")
	set_source_files_properties(
		clipboard.cpp
		network.cpp
		network_worker.cpp
		text.cpp
		PROPERTIES
			COMPILE_FLAGS "-Wno-old-style-cast")
endif(CMAKE_COMPILER_IS_GNUCXX)


########### Wesnoth main source files ###############

# Depending on whether the game or the game and the tests are build the main
# sources are compiled in the game library or not. If only one target is needed
# the putting in the game library solution is slower. If both targets are build
# the library is faster (especially if the user doesn't use ccache (or
# something similar)).

set(wesnoth-main_SRC
	about.cpp
	actions.cpp
	addon/manager.cpp
	addon/validation.cpp
	ai/actions.cpp
	ai/composite/ai.cpp
	ai/composite/aspect.cpp
	ai/composite/component.cpp
	ai/composite/contexts.cpp
	ai/composite/engine.cpp
	ai/composite/engine_default.cpp
	ai/composite/engine_fai.cpp
	ai/composite/engine_lua.cpp
	ai/composite/goal.cpp
	ai/composite/rca.cpp
	ai/composite/stage.cpp
	ai/configuration.cpp
	ai/contexts.cpp
	ai/default/ai.cpp
	ai/default/attack.cpp
	ai/default/contexts.cpp
	ai/formula/ai.cpp
	ai/formula/callable_objects.cpp
	ai/formula/candidates.cpp
	ai/formula/function_table.cpp
	ai/formula/stage_side_formulas.cpp
	ai/formula/stage_unit_formulas.cpp
	ai/game_info.cpp
	ai/gamestate_observer.cpp
	ai/interface.cpp
	ai/lua/core.cpp
	ai/lua/lua_object.cpp
	ai/manager.cpp
	ai/registry.cpp
	ai/testing.cpp
	ai/testing/aspect_attacks.cpp
	ai/testing/ca.cpp
	ai/testing/ca_global_fallback.cpp
	ai/testing/ca_testing_move_to_targets.cpp
	ai/testing/ca_testing_recruitment.cpp
	ai/testing/stage_fallback.cpp
	ai/testing/stage_rca.cpp
	animated_game.cpp
	attack_prediction.cpp
	attack_prediction_display.cpp
	callable_objects.cpp
	commandline_options.cpp
	config_cache.cpp
	controller_base.cpp
	dialogs.cpp
	editor/action.cpp
	editor/brush.cpp
	editor/editor_controller.cpp
	editor/editor_display.cpp
	editor/editor_layout.cpp
	editor/editor_main.cpp
	editor/editor_map.cpp
	editor/editor_palettes.cpp
	editor/editor_preferences.cpp
	editor/map_context.cpp
	editor/map_fragment.cpp
	editor/mouse_action.cpp
	filechooser.cpp
	floating_textbox.cpp
	formula.cpp
	formula_debugger.cpp
	formula_debugger_fwd.cpp
	formula_function.cpp
	formula_string_utils.cpp
	formula_tokenizer.cpp
	game_controller.cpp
	game_controller_abstract.cpp
	game_controller_new.cpp
	game_display.cpp
	game_errors.cpp
	game_events.cpp
	game_instance.cpp
	game_preferences.cpp
	game_preferences_display.cpp
	gamestatus.cpp
	generic_event.cpp
	gui/auxiliary/canvas.cpp
	gui/auxiliary/event/dispatcher.cpp
	gui/auxiliary/event/distributor.cpp
	gui/auxiliary/event/handler.cpp
	gui/auxiliary/iterator/iterator.cpp
	gui/auxiliary/iterator/walker_grid.cpp
	gui/auxiliary/iterator/walker_widget.cpp
	gui/auxiliary/log.cpp
	gui/auxiliary/old_markup.cpp
	gui/auxiliary/timer.cpp
	gui/auxiliary/tips.cpp
	gui/auxiliary/widget_definition.cpp
	gui/auxiliary/widget_definition/button.cpp
	gui/auxiliary/widget_definition/drawing.cpp
	gui/auxiliary/widget_definition/horizontal_scrollbar.cpp
	gui/auxiliary/widget_definition/image.cpp
	gui/auxiliary/widget_definition/label.cpp

=== debian/changelog ===
wesnoth-1.9 (1:1.9.12-1) unstable; urgency=low

  * New upstream devel release.

 -- Gerfried Fuchs <rhonda@debian.org>  Tue, 06 Dec 2011 11:50:17 +0100

=== debian/control ===
Source: wesnoth-1.9
Section: games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Build-Depends: debhelper (>= 7), libsdl-image1.2-dev, libfreetype6-dev,
  libsdl-mixer1.2-dev, libsdl-net1.2-dev, libfribidi-dev, libsdl1.2-dev,
  libsdl-ttf2.0-dev (>= 2.0.8), python-support, libdbus-1-dev,
  libboost-iostreams-dev, libboost-test-dev, libboost-regex-dev,
  libboost-serialization-dev, libboost-system-dev, libboost-thread-dev,
  libboost-program-options-dev,
  libpango1.0-dev, cmake (>= 2.6)
Standards-Version: 3.9.2
Uploaders: Gerfried Fuchs <rhonda@debian.org>
Homepage: http://wesnoth.org/
Vcs-Git: git://git.debian.org/git/pkg-games/wesnoth.git
Vcs-Browser: http://git.debian.org/?p=pkg-games/wesnoth.git;a=summary

Package: wesnoth-1.9-data
Architecture: all
Depends: ${misc:Depends}, ttf-dejavu
Recommends: ttf-wqy-zenhei (>= 0.8.38-1)
Suggests: wesnoth-1.9-music
Description: data files for Wesnoth (branch 1.9)
 This package contains the sound files and graphics for Wesnoth. It is required
 for being able to play wesnoth or create maps with the editor.
 .
 Battle for control of villages, using variety of units which have advantages
 and disadvantages in different types of terrains and against different types
 of attacks.  Units gain experience and advance levels, and are carried over
 from one scenario to the next in a campaign.

Package: wesnoth-1.9-core
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends},
  wesnoth-1.9-data (= ${source:Version})
Suggests: wesnoth
Description: fantasy turn-based strategy game (branch 1.9)
 This package contains the main program for wesnoth. It can be used to play
 multiplayer games.  If you want to play campaigns you will have to install
 them individually, but if you prefer to have all the official campaigns
 installed please be advised to install the wesnoth-1.9 package which depends
 on all of them.
 .
 Battle for control of villages, using variety of units which have advantages
 and disadvantages in different types of terrains and against different types
 of attacks.  Units gain experience and advance levels, and are carried over
 from one scenario to the next in a campaign.

Package: wesnoth-1.9-dbg
Section: debug
Architecture: any
Priority: extra
Depends: ${misc:Depends}, wesnoth-1.9-core (= ${binary:Version}),
  wesnoth-1.9-data (= ${source:Version})
Description: fantasy turn-based strategy game (debugging symbols for branch 1.9)
 This package contains the debugging symbols for the wesnoth binaries.
 .
 Battle for control of villages, using variety of units which have advantages
 and disadvantages in different types of terrains and against different types
 of attacks.  Units gain experience and advance levels, and are carried over
 from one scenario to the next in a campaign.

Package: wesnoth-1.9
Architecture: all
Depends: ${misc:Depends}, wesnoth-1.9-core (>= ${binary:Version}),
  wesnoth-1.9-core (<< ${binary:Version}.~),
  wesnoth-1.9-data (= ${source:Version}),
  wesnoth-1.9-httt (= ${source:Version}),
  wesnoth-1.9-tsg (= ${source:Version}),
  wesnoth-1.9-trow (= ${source:Version}),
  wesnoth-1.9-ttb (= ${source:Version}),
  wesnoth-1.9-ei (= ${source:Version}),
  wesnoth-1.9-utbs (= ${source:Version}),
  wesnoth-1.9-did (= ${source:Version}),
  wesnoth-1.9-nr (= ${source:Version}),
  wesnoth-1.9-sof (= ${source:Version}),
  wesnoth-1.9-sotbe (= ${source:Version}),
  wesnoth-1.9-l (= ${source:Version}),
  wesnoth-1.9-aoi (= ${source:Version}),
  wesnoth-1.9-thot (= ${source:Version}),
  wesnoth-1.9-low (= ${source:Version}),
  wesnoth-1.9-dm (= ${source:Version}),
  wesnoth-1.9-dw (= ${source:Version})
Recommends: wesnoth-1.9-music (= ${source:Version})
Description: fantasy turn-based strategy game - complete suite (branch 1.9)
 This package depends on the complete set of packages built from the wesnoth
 source package but the server (which can be found in the
 wesnoth-1.9-server package), most helpful if you always
 want to have all the official campaigns installed.  If you only want to play
 over the network with other players or want to play only a few campaigns you
 just need to install the wesnoth-1.9-core package and
 the wanted campaign packages.
 .
 Battle for control of villages, using variety of units which have advantages
 and disadvantages in different types of terrains and against different types
 of attacks.  Units gain experience and advance levels, and are carried over
 from one scenario to the next in a campaign.

Package: wesnoth-1.9-music
Architecture: all
Depends: ${misc:Depends}
Description: music files for Wesnoth (branch 1.9)
 This package contains the music files for Wesnoth. It is not required but
 gives nice background music and encouraged.
 .
 Battle for control of villages, using variety of units which have advantages
 and disadvantages in different types of terrains and against different types
 of attacks.  Units gain experience and advance levels, and are carried over
 from one scenario to the next in a campaign.

Package: wesnoth-1.9-server
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, lsb-base
Description: multiplayer network server for Wesnoth (branch 1.9)
 This package contains the multiplayer network server for Wesnoth.  You need it
 if you want to host multiplayer games on your computer and don't want to use
 the official servers.
 .
 Battle for control of villages, using variety of units which have advantages
 and disadvantages in different types of terrains and against different types
 of attacks.  Units gain experience and advance levels, and are carried over
 from one scenario to the next in a campaign.

Package: wesnoth-1.9-tools
Architecture: all
Depends: ${misc:Depends}, ${shlibs:Depends}, ${python:Depends},
  wesnoth-1.9-data (= ${source:Version})
Enhances: wesnoth-1.9-core
Description: tools for campaign developers for Wesnoth (branch 1.9)
 This package contains various tools for Wesnoth that are especially useful for
 campaign developers, including but not limited to scripts supporting the
 generation and checking of WML (Wesnoth Markup Language).  You can find them
 in the directory /usr/share/games/wesnoth/1.9/data/tools
 after installation of the package.
 .
 Battle for control of villages, using variety of units which have advantages
 and disadvantages in different types of terrains and against different types
 of attacks.  Units gain experience and advance levels, and are carried over
 from one scenario to the next in a campaign.

Package: wesnoth-1.9-httt
Depends: ${misc:Depends}, wesnoth-1.9-core (>= ${wesnoth:Min-Version}),
  wesnoth-1.9-core (<< ${wesnoth:Max-Version})
Architecture: all
Description: "Heir to the Throne" official campaign for Wesnoth (branch 1.9)
 This package contains the "Heir to the Throne" campaign for Wesnoth:
 "Fight to regain the throne of Wesnoth, of which you are the legitimate
 heir."
 (Novice level, 25 scenarios.)
 .
 Battle for control of villages, using variety of units which have advantages
 and disadvantages in different types of terrains and against different types
 of attacks.  Units gain experience and advance levels, and are carried over
 from one scenario to the next in a campaign.

Package: wesnoth-1.9-tsg
Depends: ${misc:Depends}, wesnoth-1.9-core (>= ${wesnoth:Min-Version}),
  wesnoth-1.9-core (<< ${wesnoth:Max-Version})
Architecture: all
Description: "The South Guard" official campaign for Wesnoth (branch 1.9)
 This package contains the "The South Guard" campaign for Wesnoth:
 "A young Knight, Deoran, is dispatched to take command of the South Guard...
 Note: This campaign is designed as an introduction to Wesnoth. The 'Civilian'
 difficulty level is aimed at first-time players."
 (Novice level, 9 or 10 scenarios depending on the branch you take.)
 .
 Battle for control of villages, using variety of units which have advantages
 and disadvantages in different types of terrains and against different types
 of attacks.  Units gain experience and advance levels, and are carried over
 from one scenario to the next in a campaign.

Package: wesnoth-1.9-trow
Depends: ${misc:Depends}, wesnoth-1.9-core (>= ${wesnoth:Min-Version}),
  wesnoth-1.9-core (<< ${wesnoth:Max-Version})
Architecture: all
Description: "The Rise of Wesnoth" official campaign for Wesnoth (branch 1.9)
 This package contains the "The Rise of Wesnoth" campaign for Wesnoth:
 "Lead Prince Haldric through the destruction of the Green Isle and across the
 Ocean to establish the very kingdom of Wesnoth itself. The confrontation with
 Lich-Lord Jevyan awaits..."
 (Intermediate level, 25 scenarios.)
 .
 Battle for control of villages, using variety of units which have advantages
 and disadvantages in different types of terrains and against different types
 of attacks.  Units gain experience and advance levels, and are carried over
 from one scenario to the next in a campaign.

Package: wesnoth-1.9-ttb
Depends: ${misc:Depends}, wesnoth-1.9-core (>= ${wesnoth:Min-Version}),
  wesnoth-1.9-core (<< ${wesnoth:Max-Version})
Architecture: all
Description: "A Tale of Two Brothers" official campaign for Wesnoth (branch 1.9)
 This package contains the "A Tale of Two Brothers" campaign for Wesnoth:
 "An evil mage is threatening the local village and its inhabitants. When their
 leader Bjarn sends for aid from his brother Arne, he is victorious, but Bjarn
 himself is kidnapped. Can you rescue him?"
 (Novice level, 4 scenarios; the 'Hard' version may challenge more experienced
 players.)
 .
 Battle for control of villages, using variety of units which have advantages
 and disadvantages in different types of terrains and against different types
 of attacks.  Units gain experience and advance levels, and are carried over
 from one scenario to the next in a campaign.

Package: wesnoth-1.9-ei
Depends: ${misc:Depends}, wesnoth-1.9-core (>= ${wesnoth:Min-Version}),
  wesnoth-1.9-core (<< ${wesnoth:Max-Version})
Architecture: all
Description: "The Eastern Invasion" official campaign for Wesnoth (branch 1.9)
 This package contains the "The Eastern Invasion" campaign for Wesnoth:
 "There are rumors of undead attacks on the eastern border of Wesnoth. You, an
 officer in the Royal Army, have been sent to the eastern front to protect the
 villagers and find out what is happening."
 (Intermediate level, 18 scenarios.)"
 .
 Battle for control of villages, using variety of units which have advantages
 and disadvantages in different types of terrains and against different types
 of attacks.  Units gain experience and advance levels, and are carried over
 from one scenario to the next in a campaign.

Package: wesnoth-1.9-utbs
Depends: ${misc:Depends}, wesnoth-1.9-core (>= ${wesnoth:Min-Version}),
  wesnoth-1.9-core (<< ${wesnoth:Max-Version})
Architecture: all
Description: "Under the Burning Suns" official campaign for Wesnoth (branch 1.9)
 This package contains the "Under the Burning Suns" campaign for Wesnoth:
 "In the distant future a small band of elves struggles to survive amidst the
 ruins of fallen empires. Lead your people out of the desert on an epic journey
 to find a new home."
 (Expert level, 11 scenarios, some under reconstruction)
 .
 Battle for control of villages, using variety of units which have advantages
 and disadvantages in different types of terrains and against different types
 of attacks.  Units gain experience and advance levels, and are carried over
 from one scenario to the next in a campaign.

Package: wesnoth-1.9-did
Depends: ${misc:Depends}, wesnoth-1.9-core (>= ${wesnoth:Min-Version}),
  wesnoth-1.9-core (<< ${wesnoth:Max-Version})
Architecture: all
Description: "Descent Into Darkness" official campaign for Wesnoth (branch 1.9)
 This package contains the "Descent Into Darkness" campaign for Wesnoth:
 "Learn the dark arts of necromancy in order to save your people from an orcish
 incursion."
 (Expert level, 11 scenarios.)
 .
 Battle for control of villages, using variety of units which have advantages

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules for wesnoth
# copyright 2007-2011 by Gerfried Fuchs <rhonda@debian.org>
# Licenced under WTFPLv2

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

CFLAGS = -g
ifneq (,$(filter noopt,$(DEB_BUILD_OPTIONS)))
        CFLAGS += -O0
else
        CFLAGS += -O2
endif
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	MAKEFLAGS += -j$(NUMJOBS)
endif


# calculate the version strings
MAJOR_VERSION = $(shell dpkg-parsechangelog | grep "^Version:" | cut -d" " -f2 | cut -d. -f1)
STRIP_MAJOR   = $(shell echo $(MAJOR_VERSION) | rev | cut -d: -f1 | rev)
MINOR_VERSION = $(shell dpkg-parsechangelog | grep "^Version:" | cut -d" " -f2 | cut -d. -f2 | cut -d- -f1 | sed -e 's/[^0-9]//g')
ISDEV_VERSION = $(shell echo $$(( $(MINOR_VERSION) % 2 )) )
UPSTR_VERSION =  $(shell dpkg-parsechangelog | grep "^Version:" | cut -d" " -f2 | rev | cut -d- -f2 | rev)

## choose correct MIN_VERSION/MAX_VERSION depending on ISDEV_VERSION
ifeq ($(ISDEV_VERSION), 1)
	MIN_VERSION = $(UPSTR_VERSION)
	MAX_VERSION = $(UPSTR_VERSION).~
else
	MIN_VERSION = $(MAJOR_VERSION).$(MINOR_VERSION)
	MAX_VERSION = $(MAJOR_VERSION).$(shell echo $$(( $(MINOR_VERSION) + 1 )) )
endif

## used for package name extension
BRANCH_VERSION = $(STRIP_MAJOR).$(MINOR_VERSION)

CONFIGURE_SWITCHES = --host=$(DEB_HOST_GNU_TYPE) --build=$(DEB_BUILD_GNU_TYPE) --disable-strict-compilation --disable-maintainer-mode --disable-rpath --prefix=/usr --mandir=\$${prefix}/share/man --bindir=\$${prefix}/games --with-datadir-name=wesnoth/$(BRANCH_VERSION) --with-localedir=\$${prefix}/share/games/wesnoth/$(BRANCH_VERSION)/locale --with-fifodir=/var/run/wesnothd --datadir=\$${prefix}/share/games --enable-server --with-fribidi --enable-python-install

CMAKE_SWITCHES = -DBINARY_SUFFIX="-$(BRANCH_VERSION)" -DCMAKE_INSTALL_PREFIX="/usr/" -DBINDIR="/usr/games" -DDATAROOTDIR="/usr/share/games" -DDATADIRNAME="wesnoth/$(BRANCH_VERSION)" -DDESKTOPDIR="/usr/share/applications" -DDOCDIR="/usr/share/doc/wesnoth-$(BRANCH_VERSION)-data" -DLOCALEDIR="locale" -DMANDIR="/usr/share/man" -DUSE_ANA_NETWORK=OFF -DCMAKE_VERBOSE_MAKEFILE=on -DENABLE_OMP=ON


clean:
	dh_testdir
	dh_testroot
	rm -f debian/stamp-*
	# Add here commands to clean up after the build process.
	rm -rf build locale # locale doesn't get generated inside build ...
	dh_clean


configure: debian/stamp-configure
debian/stamp-configure:
	mkdir -p build
	cd build && \
		cmake .. $(CMAKE_SWITCHES)
	# CFLAGS="$(CFLAGS)" LDFLAGS="-Wl,-z,defs" ./configure $(CONFIGURE_SWITCHES)
	touch $@


build: build-arch build-indep
build-arch: debian/stamp-build
build-indep: debian/stamp-build

debian/stamp-build: debian/stamp-configure
	$(MAKE) -C build
	touch $@


install: debian/stamp-install
debian/stamp-install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs

	$(MAKE) -C build DESTDIR=$(CURDIR)/debian/tmp install

	cd $(CURDIR)/debian/tmp/usr/share/games/wesnoth/$(BRANCH_VERSION)/data/tools \
		&& chmod +x extractbindings unit_tree/TeamColorizer \
		wesnoth/wescamp.py wesnoth/wmldata.py wesnoth/wmlparser.py \
		wmlindent wmlflip wmllint wmlscope wesnoth_addon_manager \
		wmlvalidator hexometer/hexometer wmlxgettext imgcheck

	dh_install

	touch $@



# Must not depend on anything. This is to be called by
# binary-arch/binary-indep
# in another 'make' thread.
binary-common:
	dh_testdir
	dh_testroot
	dh_installchangelogs changelog
	dh_installdocs
	dh_installexamples
	dh_installmenu
	dh_lintian
	dh_pysupport
	dh_installinit -u 'stop 20 0 1 2 3 4 5 6 .'
	dh_installman
	dh_strip --dbg-package=wesnoth-$(BRANCH_VERSION)-dbg
	dh_compress
	dh_fixperms
	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol -- \
		-Vwesnoth:Min-Version=$(MIN_VERSION) \
		-Vwesnoth:Max-Version=$(MAX_VERSION) \
		-Vwesnoth:Branch-Version=$(BRANCH_VERSION)
	dh_md5sums
	dh_builddeb


# Build architecture independant packages using the common target.
binary-indep: install
	# workaround for dh_link (mis)behavior, see BTS#445550
	for i in ttf-dejavu/DejaVuSans.ttf; \
		do ln -s /usr/share/fonts/truetype/$$i \
	       	debian/wesnoth-$(BRANCH_VERSION)-data/usr/share/games/wesnoth/$(BRANCH_VERSION)/fonts/`basename $$i`; \
		done
	ln -s /usr/share/fonts/truetype/wqy/wqy-zenhei.ttc \
	       	debian/wesnoth-$(BRANCH_VERSION)-data/usr/share/games/wesnoth/$(BRANCH_VERSION)/fonts/wqy-zenhei.ttc

	# rename icons versioned
	mv debian/wesnoth-$(BRANCH_VERSION)-data/usr/share/icons/wesnoth-icon.png \
		debian/wesnoth-$(BRANCH_VERSION)-data/usr/share/icons/wesnoth-$(BRANCH_VERSION)-icon.png
	mv debian/wesnoth-$(BRANCH_VERSION)-data/usr/share/icons/wesnoth_editor-icon.png \
		debian/wesnoth-$(BRANCH_VERSION)-data/usr/share/icons/wesnoth-$(BRANCH_VERSION)_editor-icon.png

	# /usr/share/doc symlinks
	for i in wesnoth-$(BRANCH_VERSION); do \
		install -p -d -m755 debian/$$i/usr/share/doc; \
		ln -s wesnoth-$(BRANCH_VERSION)-data debian/$$i/usr/share/doc/$$i; \
		done

	$(MAKE) -f debian/rules DH_OPTIONS=-i binary-common

# Build architecture dependant packages using the common target.
binary-arch: install
	# manpage symlinks for old binaries
	for i in debian/wesnoth-$(BRANCH_VERSION)-core/usr/share/man/*/man6/wesnoth.6; do \
		ln -s wesnoth-$(BRANCH_VERSION).6.gz \
			`dirname $$i`/wesnoth-$(BRANCH_VERSION)-nolog.6.gz; \
		ln -s wesnoth-$(BRANCH_VERSION).6.gz \
			`dirname $$i`/wesnoth-$(BRANCH_VERSION)-smallgui.6.gz; \
		ln -s wesnoth-$(BRANCH_VERSION).6.gz \
			`dirname $$i`/wesnoth-$(BRANCH_VERSION)_editor.6.gz; \
		done
	ln -s wesnoth-$(BRANCH_VERSION).6.gz \
		debian/wesnoth-$(BRANCH_VERSION)-core/usr/share/man/man6/wesnoth-$(BRANCH_VERSION)-nolog.6.gz
	ln -s wesnoth-$(BRANCH_VERSION).6.gz \
		debian/wesnoth-$(BRANCH_VERSION)-core/usr/share/man/man6/wesnoth-$(BRANCH_VERSION)-smallgui.6.gz
	ln -s wesnoth-$(BRANCH_VERSION).6.gz \
		debian/wesnoth-$(BRANCH_VERSION)-core/usr/share/man/man6/wesnoth-$(BRANCH_VERSION)_editor.6.gz

	# move the manpages to their proper name
	for i in debian/wesnoth-$(BRANCH_VERSION)-core/usr/share/man/man6/wesnoth.6 \
		debian/wesnoth-$(BRANCH_VERSION)-core/usr/share/man/*/man6/wesnoth.6; do \
		mv $$i $$(echo $$i | sed -e 's/wesnoth\.6/wesnoth-$(BRANCH_VERSION).6/'); \
		done
	for i in debian/wesnoth-$(BRANCH_VERSION)-server/usr/share/man/man6/wesnothd.6 \
		debian/wesnoth-$(BRANCH_VERSION)-server/usr/share/man/*/man6/wesnothd.6; do \
		mv $$i $$(echo $$i | sed -e 's/wesnothd\.6/wesnothd-$(BRANCH_VERSION).6/'); \
		done

	# move the desktop files to their proper name
	mv debian/wesnoth-$(BRANCH_VERSION)-core/usr/share/applications/wesnoth.desktop \
		debian/wesnoth-$(BRANCH_VERSION)-core/usr/share/applications/wesnoth-$(BRANCH_VERSION).desktop
	mv debian/wesnoth-$(BRANCH_VERSION)-core/usr/share/applications/wesnoth_editor.desktop \
		debian/wesnoth-$(BRANCH_VERSION)-core/usr/share/applications/wesnoth-$(BRANCH_VERSION)_editor.desktop
	# add branch name to desktop entries
	sed -i -e "/^Name/ s/$$/ ($(BRANCH_VERSION))/" \
		debian/wesnoth-$(BRANCH_VERSION)-core/usr/share/applications/*.desktop


	# /usr/share/doc symlinks
	for i in wesnoth-$(BRANCH_VERSION)-core wesnoth-$(BRANCH_VERSION)-dbg; do \
		install -p -d -m755 debian/$$i/usr/share/doc; \
		ln -s wesnoth-$(BRANCH_VERSION)-data debian/$$i/usr/share/doc/$$i; \
		done

	$(MAKE) -f debian/rules DH_OPTIONS=-s binary-common


binary: binary-arch binary-indep
.PHONY: clean configure build binary-indep binary-arch binary install patch unpatch
